'use strict';const proxyquire=require('proxyquire'),utils=require('../../../test/utils'),findCharmEntries=sinon.stub(),getEntries=sinon.stub(),readCharmEntries=sinon.stub(),jsYamlMock=sinon.stub(),EnvironmentView=proxyquire('./environment',{"./service":proxyquire('./service',{d3:{mouse:sinon.stub().returns([0,0])},"js-yaml":{safeLoad:jsYamlMock},"../zip-utils":{findCharmEntries:findCharmEntries,getEntries:getEntries,readCharmEntries:readCharmEntries}})});describe('service module annotations',function(){let a,b,c,d,e,f,g;beforeAll(function(a){YUI(GlobalConfig).use(['juju-models'],function(c){b=c.namespace('juju.models'),window.yui=c,a()})}),beforeEach(function(){d=utils.makeContainer(this),a=new b.Database({getECS:sinon.stub().returns({changeSet:{}})}),f=!1,g={"gui-x":0,"gui-y":0};c=new EnvironmentView({container:d,db:a,env:{update_annotations:function(a,b,c){f=!0,g['gui-x']=c['gui-x'],g['gui-y']=c['gui-y']},get:function(){}},state:{changeState:sinon.stub()}}),c.render(),c.rendered(),e=c.topo.modules.ServiceModule,e.useTransitions=!1}),afterEach(function(){c.destructor(),d.remove()}),it('should set location annotations on service block drag end',function(){const a={id:'wordpress',inDrag:e.DRAG_ACTIVE,x:100.1,y:200.2};e.dragend(a,e),assert.isTrue(f),g['gui-x'].should.equal(100.1),g['gui-y'].should.equal(200.2)}),it('should not set annotations on drag end if building a relation',function(){const a=e.topo;a.buildingRelation=!0,e.dragend({id:'wordpress',x:100.1,y:200.2},e),assert.isFalse(f),g['gui-x'].should.equal(0),g['gui-y'].should.equal(0)}),it('should clear the state when the event is fired',function(){const a=e.topo,b=sinon.stub();a.state={changeState:b},e.clearStateHandler(),assert.equal(b.callCount,1),assert.deepEqual(b.args[0][0],{hash:null,profile:null,root:null,user:null,gui:{machines:null,inspector:null},search:null,store:null})})}),describe('service updates',function(){let a,b,c,d,e;beforeAll(function(a){YUI(GlobalConfig).use(['juju-models'],function(c){b=c.namespace('juju.models'),window.yui=c,a()})}),beforeEach(function(){d=utils.makeContainer(this),a=new b.Database({getECS:sinon.stub().returns({changeSet:{}})}),c=new EnvironmentView({container:d,db:a,env:{update_annotations:function(){}},state:{changeState:sinon.stub()}}),c.render(),c.rendered(),e=c.topo.modules.ServiceModule}),afterEach(function(){c.destructor(),d.remove()}),it('should resize when subordinate status changes',function(){a.services.add({id:'foo',subordinate:!1}),e.update();const b=e.topo.vis.select('.service');assert.equal(b.select('.service-block').attr('cx'),95),a.services.item(0).set('subordinate',!0),e.update(),assert.equal(b.select('.service-block').attr('cx'),65)}),it('should center on first load',function(b){let c=0;e.panToCenter=function(){c+=1,1<c&&(assert.fail('panToCenter should only be called once on load'),b()),assert.equal(e.centerOnLoad,!1),b()},a.services.add({id:'foo',subordinate:!1}),e.update(),e.update()})}),describe('service module events',function(){let a,b,c,d,e,f,g,h,i;beforeAll(function(a){YUI(GlobalConfig).use(['juju-models'],function(b){e=b.namespace('juju.models'),window.yui=b,window.models=e,a()})}),beforeEach(function(j){a=[],d=new window.jujulib.charmstore('http://1.2.3.4/'),d.getIconPath=function(){return'charm icon url'},i=utils.makeContainer(this,'content');const k=utils.loadFixture('data/haproxy-api-response.json',!0);c=new e.Charm(k.charm),b=new e.Database({getECS:sinon.stub().returns({changeSet:{}})}),b.services.add({id:'haproxy',charm:'cs:precise/haproxy-18'}),b.charms.add(c),h=new EnvironmentView({container:i,db:b,env:{update_annotations:function(){},get:function(){}},charmstore:d,state:{changeState:sinon.stub()}}),h.render(),h.rendered(),g=h.topo,f=g.modules.ServiceModule,j()}),afterEach(function(){a.forEach((a)=>a()),c.destroy(),b.destroy(),g.destructor(),h.destructor(),i.remove()}),it('should notify modules when service type is changed',function(a){const b=()=>{document.removeEventListener('topo.rerenderRelations',b),a()};document.addEventListener('topo.rerenderRelations',b),g.service_boxes.haproxy.model.set('highlighted',!0),f.update()}),it('must not process service clicks after a dragend',function(){const a=h.topo;let b=!1;f.fake=function(){b=!0},f.currentServiceClickAction='fake',a.ignoreServiceClick=!0,f.serviceClick({id:'wordpress',containsPoint:function(){return!0}},f),assert.equal(b,!1),assert.equal(a.ignoreServiceClick,!1)}),it('should show only visible services',function(){b.services.add([{id:'rails',life:'dying'},{id:'mysql',life:'dead'}]),b.services.add({id:'django'}),b.services.add({id:'wordpress',life:'dying',aggregated_status:{error:42}});const c=sinon.stub(f,'unhighlight');a.push(c.restore),f.update();const d=g.service_boxes;assert.strictEqual(5,b.services.size(),'total'),assert.strictEqual(4,Object.keys(d).length,'displayed'),assert.isNotNull(d.haproxy),assert.isObject(d.haproxy),assert.isNotNull(d.django),assert.isObject(d.django),assert.isNotNull(d.wordpress),assert.isObject(d.wordpress)}),xit('should highlight and unhighlight services',function(){f.highlight({serviceName:'haproxy'}),assert.equal(g.service_boxes.haproxy.highlighted,!0),assert.equal(g.vis.select('.service-block-image').attr('href'),'/static/gui/build/app/assets/svgs/service_module_selected.svg'),assert.notEqual(g.vis.select('.service.highlight')[0][0],null,'Highlight class not found'),f.unhighlight({serviceName:'haproxy'}),assert.equal(g.service_boxes.haproxy.highlighted,!1),assert.equal(g.vis.select('.service-block-image').attr('href'),'/static/gui/build/app/assets/svgs/service_module.svg'),assert.notEqual(g.vis.select('.service.unhighlight')[0][0],null,'Unhighlight class not found')}),it('should highlight and unhighlight related services',function(){b.services.add({id:'wordpress'}),b.relations.add({interface:'proxy',scope:'global',endpoints:[['haproxy',{role:'server',name:'haproxy'}],['wordpress',{role:'client',name:'wordpress'}]],id:'relation1'}),f.update(),f.highlight({serviceName:'haproxy',highlightRelated:!0}),assert.equal(g.service_boxes.wordpress.highlighted,!0),f.unhighlight({serviceName:'haproxy',unhighlightRelated:!0}),assert.equal(g.service_boxes.wordpress.highlighted,!1)}),it('can generate a selection from a list of service names',function(){assert.deepEqual(f.selectionFromServiceNames(['haproxy']),g.vis.selectAll('.service'))}),it('should pan to a deployed bundle',function(){const c=sinon.stub(f,'findCentroid');a.push(c.restore),b.services.add([{id:'apache2',pending:!0,annotations:{"gui-x":100,"gui-y":100}}]),f.update(),f.panToBundle({services:[b.services.item(0)]}),assert.equal(c.calledOnce,!0,'findCentroid not called')}),it('should deploy a service on charm token drop events',function(a){const b='/static/gui/build/app/assets/svgs/service_health_mask.svg',c={dataTransfer:{getData:function(){return JSON.stringify({data:'{"id": "cs:xenial/bar-1"}',dataType:'token-drag-and-drop',iconSrc:b})}},target:{},clientX:155,clientY:153,preventDefault:sinon.stub()},d=(f)=>{document.removeEventListener('initiateDeploy',d),assert.deepEqual(f.detail.ghostAttributes,{coordinates:[52.5,-52],icon:b}),assert.equal(c.preventDefault.callCount,1),a()};document.addEventListener('initiateDeploy',d),f.topo=g,f.canvasDropHandler(c)}),it('should deploy a bundle on bundle token drop events',function(a){const b={dataTransfer:{getData:function(){return JSON.stringify({data:'{"data": "BUNDLE DATA", "id": "~jorge/bundle/thing"}',dataType:'token-drag-and-drop',iconSrc:'/static/gui/build/app/assets/svgs/service_health_mask.svg'})}},target:{},clientX:155,clientY:153,preventDefault:sinon.stub()};h.topo.charmstore={getBundleYAML:function(a,b){b(null,{target:{responseText:'bundle: BUNDLE DATA'}})}},h.topo.bundleImporter={importBundleYAML:function(b){assert.equal(b.target.responseText,'bundle: BUNDLE DATA'),a()}},f.topo=h.topo,f.canvasDropHandler(b)}),it('should deploy a bundle on file drop events',function(a){const b={name:'',type:''},c={dataTransfer:{files:[b]},preventDefault:sinon.stub()};h.topo.bundleImporter={importBundleFile:function(c){assert.deepEqual(c,b),a()}},f.topo=h.topo,f.canvasDropHandler(c)}),it('calls to extract local charm on .zip file drop events',function(){const b={name:'foo-bar.baz.zip',type:'application/zip'},c={dataTransfer:{files:[b]},preventDefault:sinon.stub()};f.topo=h.topo;const d=sinon.stub(f,'_extractCharmMetadata');a.push(d.restore),f.canvasDropHandler(c),assert.equal(d.calledOnce,!0);const e=d.lastCall.args;assert.deepEqual(e[0],b),assert.deepEqual(e[1],g),assert.deepEqual(e[2],g.env),assert.deepEqual(e[3],g.db)}),it('calls to extract local charm on .zip file drop events (IE)',function(){const b={name:'foo-bar.baz.zip',type:'application/x-zip-compressed'},c={dataTransfer:{files:[b]},preventDefault:sinon.stub()};f.topo=h.topo;const d=sinon.stub(f,'_extractCharmMetadata');a.push(d.restore),f.canvasDropHandler(c),assert.equal(d.calledOnce,!0);const e=d.lastCall.args;assert.deepEqual(e[0],b),assert.deepEqual(e[1],g),assert.deepEqual(e[2],g.env),assert.deepEqual(e[3],g.db)}),it('_extractCharmMetadata: calls ziputils.getEntries()',function(){const b={file:''},c={topo:''},d={env:''},e={db:''},g=sinon.stub(f,'_findCharmEntries');a.push(g.restore);const h=sinon.stub(f,'_zipExtractionError');a.push(h),f._extractCharmMetadata(b,c,d,e),assert.equal(getEntries.calledOnce,!0);const i=getEntries.lastCall.args;assert.equal(i[0],b),assert.isFunction(i[1]),assert.isFunction(i[2]),i[1]();const j=g.lastCall.args;assert.deepEqual(j[0],b),assert.deepEqual(j[1],c),assert.deepEqual(j[2],d),assert.deepEqual(j[3],e),i[2]();const k=h.lastCall.args;assert.deepEqual(k[0],e)}),describe('_findCharmEntries',function(){let b,c,d,e,g;beforeEach(function(){d={name:'foo'},e={topo:''},c={env:''},b={notifications:{add:function(a){g=a}}}}),it('finds the files in the zip',function(){const g={metadata:'foo'};findCharmEntries.returns(g);const h=sinon.stub(f,'_readCharmEntries');a.push(h.restore),f._findCharmEntries(d,e,c,b,{}),assert.equal(findCharmEntries.calledOnce,!0),assert.deepEqual(findCharmEntries.lastCall.args[0],{}),assert.equal(h.calledOnce,!0);const i=h.lastCall.args;assert.deepEqual(i[0],d),assert.deepEqual(i[1],e),assert.deepEqual(i[2],c),assert.deepEqual(i[3],b),assert.deepEqual(i[4],g)}),it('shows an error notification if there is no metadata.yaml',function(){findCharmEntries.returns({foo:'bar'});const h=sinon.stub(f,'_readCharmEntries');a.push(h.restore),e.environmentView={fadeHelpIndicator:sinon.stub()},f._findCharmEntries(d,e,c,b,{}),assert.equal(1<=findCharmEntries.callCount,!0),assert.deepEqual(findCharmEntries.lastCall.args[0],{}),assert.deepEqual(g,{title:'Import failed',message:'Import from "'+d.name+'" failed. Invalid charm file, missing metadata.yaml',level:'error'}),assert.equal(h.calledOnce,!1)})}),it('_readCharmEntries: calls ziputils.readCharmEntries',function(){const b={file:''},c={topo:''},d={env:''},e={db:''},g=sinon.stub(f,'_checkForExistingServices');a.push(g);const h=sinon.stub(f,'_zipExtractionError');f._readCharmEntries(b,c,d,e,{}),assert.equal(readCharmEntries.calledOnce,!0);const i=readCharmEntries.lastCall.args;assert.deepEqual(i[0],{}),assert.isFunction(i[1]),assert.isFunction(i[2]),i[1]();const j=g.lastCall.args;assert.deepEqual(j[0],b),assert.deepEqual(j[1],c),assert.deepEqual(j[2],d),assert.deepEqual(j[3],e),i[2]();const k=h.lastCall.args;assert.deepEqual(k[0],e),assert.deepEqual(k[1],c),assert.deepEqual(k[2],b)}),describe('_checkForExistingService',function(){function a(){jsYamlMock.returns({name:'ghost'}),d=sinon.stub(f,'_deployLocalCharm'),k.push(d.restore)}function b(){assert.equal(1<=jsYamlMock.callCount,!0),assert.equal(j.calledOnce,!0),assert.equal(l.calledOnce,!0)}let c,d,e,g,i,j,k,l,m;beforeEach(function(){k=[],i={name:'foo'},l=sinon.stub(),m={},h.topo.state.changeState=l,g={env:'foo'},e={metadata:'foo'}}),afterEach(()=>{k.forEach((a)=>a())}),it('calls to show the upgrade or new inspector',function(){a(this),j=sinon.stub().returns(['service']),c={services:{getServicesFromCharmName:j}},f._checkForExistingServices(i,m,g,c,e),b(),assert.equal(d.calledOnce,!1)}),it('calls to deploy the local charm',function(){a(this),j=sinon.stub().returns(['service']),c={services:{getServicesFromCharmName:j}},f._checkForExistingServices(i,m,g,c,e),b(),assert.equal(d.calledOnce,!1)})}),it('shows a notification if there is a zip error',function(){let a;const b={name:'foo'},c=sinon.stub();f._zipExtractionError({notifications:{add:function(b){a=b}}},{environmentView:{fadeHelpIndicator:c}},b),assert.deepEqual(a,{title:'Import failed',message:'Import from "'+b.name+'" failed. See console for error object',level:'error'}),assert.equal(c.callCount,1)}),it('_showUpgradeOrNewInspector: shows the inspector',function(){const a=f.topo.state.changeState;f._showUpgradeOrNewInspector([{getAttrs:function(){}}],{name:'foo'},{env:'env'},{db:'db'}),assert.equal(a.callCount,1),assert.deepEqual(a.lastCall.args[0],{gui:{inspector:{id:null,localType:'update'}}})}),it('_deployLocalCharm: calls to show the inspector',function(){const a=f.topo.state.changeState;f._deployLocalCharm({name:'foo'},{env:'env'},{db:'db'}),assert.equal(a.callCount,1),assert.deepEqual(a.lastCall.args[0],{gui:{inspector:{id:null,localType:'new'}}})})}),describe('canvasDropHandler',function(){let a,b,c,d;beforeAll(function(b){YUI(GlobalConfig).use(['juju-models'],function(c){a=c.namespace('juju.models'),window.yui=c,b()})}),beforeEach(function(){d=utils.makeContainer(this);const e=new a.Database({getECS:sinon.stub().returns({changeSet:{}})});c=new EnvironmentView({container:d,db:e,env:{update_annotations:function(){},get:function(){}},state:{changeState:sinon.stub()}}),c.render(),c.rendered(),b=c.topo.modules.ServiceModule,b.useTransitions=!1}),afterEach(function(){c.destructor(),d.remove()}),it('defers its implementatino to _canvasDropHandler',function(){const a={length:2},c={dataTransfer:{files:a},preventDefault:sinon.stub()};assert.equal(b.canvasDropHandler(c),b._canvasDropHandler(a))}),it('halts the event so FF does not try to reload the page',function(a){b.canvasDropHandler({dataTransfer:{files:{length:2}},preventDefault:()=>{a()}})})}),describe('_canvasDropHandler',function(){let a,b,c,d;beforeAll(function(b){YUI(GlobalConfig).use(['juju-models'],function(c){a=c.namespace('juju.models'),window.yui=c,b()})}),beforeEach(function(){d=utils.makeContainer(this);const e=new a.Database({getECS:sinon.stub().returns({changeSet:{}})});c=new EnvironmentView({container:d,db:e,env:{update_annotations:function(){},get:function(){}},state:{changeState:sinon.stub()}}),c.render(),c.rendered(),b=c.topo.modules.ServiceModule,b.useTransitions=!1}),afterEach(function(){c.destructor(),d.remove()}),it('ignores drop events that contain more than one file',function(){assert.equal(b._canvasDropHandler({length:2}),'event ignored')}),it('deploys charms dropped from the sidebar',function(a){b._canvasDropHandler.call({_deployFromCharmbrowser:function(){a()}},{})}),it('extracts a zipped charm directory when dropped',function(a){b._canvasDropHandler.call({_extractCharmMetadata:function(){a()}},[{name:'charm.zip',type:'application/zip'}])}),it('recognizes zip files of type x-zip-compressed',function(a){b._canvasDropHandler.call({_extractCharmMetadata:function(){a()}},{length:1,0:{name:'charm.zip',type:'application/x-zip-compressed'}})})}),describe('updateElementVisibility',function(){let a,b,c,d,e;beforeAll(function(a){YUI(GlobalConfig).use(['juju-models'],function(c){b=c.namespace('juju.models'),window.yui=c,a()})}),beforeEach(function(){a=[],e=utils.makeContainer(this);const f=new b.Database({getECS:sinon.stub().returns({changeSet:{}})});d=new EnvironmentView({container:e,db:f,env:{update_annotations:function(){},get:function(){}},state:{changeState:sinon.stub()}}),d.render(),d.rendered(),c=d.topo.modules.ServiceModule,c.useTransitions=!1}),afterEach(()=>{a.forEach((a)=>a()),a=null,d.destructor(),e.remove()}),it('is called on update',function(){c.rendered=!0,c.service_scale=!0,c.dragBehaviour=!0;const b=sinon.stub(c,'updateElementVisibility'),d=sinon.stub(c,'updateData');a.push(d.restore),a.push(b.restore),c.update(),assert.equal(b.callCount,1)}),it('categorizes and calls the appropriate vis method',function(){const d=sinon.stub(c,'fade'),e=sinon.stub(c,'hide'),f=sinon.stub(c,'show'),g=sinon.stub(c,'highlight'),h=sinon.stub(c,'unhighlight');a.concat([d.restore,e.restore,f.restore,g.restore,h.restore]);const i=new b.ServiceList;i.add([{id:'foo1',fade:!0},{id:'foo2',hide:!0},{id:'foo3',highlight:!0},{id:'foo4'}]),c.topo.db.services=i,c.updateElementVisibility(),assert.equal(d.callCount,1),assert.deepEqual(d.lastCall.args[0],{serviceNames:['foo1']}),assert.equal(e.callCount,1),assert.deepEqual(e.lastCall.args[0],{serviceNames:['foo2']}),assert.equal(f.callCount,3),assert.deepEqual(f.args,[[{serviceNames:['foo1']}],[{serviceNames:['foo3']}],[{serviceNames:['foo4']}]]),assert.equal(g.callCount,1),assert.deepEqual(g.lastCall.args[0],{serviceName:['foo3']}),assert.equal(h.callCount,3),assert.deepEqual(h.args,[[{serviceName:['foo1']}],[{serviceName:['foo2']}],[{serviceName:['foo4']}]])})});