'use strict';const utils=require('./utils');describe('topology utils',()=>{it('should translate service boxes to vertices',()=>{const a=utils.serviceBoxesToVertices({one:{x:100,y:100},two:{x:200,y:100},red:{x:100,y:200},blue:{x:200,y:200}});assert.deepEqual(a,[[100,100],[200,100],[100,200],[200,200]])}),it('translates service boxes to centers coordinates',()=>{const a=utils.serviceBoxesToVertices({one:{center:[10,20]},two:{center:[30,40]}});assert.deepEqual(a,[[10,20],[30,40]])}),it('translates service boxes falling back to vertices',()=>{const a={one:{center:[NaN,NaN],x:20,y:40},two:{center:[NaN,NaN],x:100,y:200}},b=utils.serviceBoxesToVertices(a);assert.deepEqual(b,[[20,40],[100,200]])}),it('should place points outside a graph',()=>{const a=[];assert.deepEqual(utils.pointOutside(a,100),[100,100]),a.push([100,100]),assert.deepEqual(utils.pointOutside(a,100),[200,100]),a.push([100,200]),assert.deepEqual(utils.pointOutside(a,100),[200,200]),a.push([200,200]),assert.deepEqual(utils.pointOutside(a,100),[300,200]),a.pop(),a.push([100,300]),assert.deepEqual(utils.pointOutside(a,100),[200,300])}),it('should generate a centroid for one or more points',()=>{const a=[];assert.deepEqual(utils.centroid(a),[0,0]),a.push([100,100]),assert.deepEqual(utils.centroid(a),[100,100]),a.push([200,200]),assert.deepEqual(utils.centroid(a),[150,150]),a.push([100,200]),a.push([200,100]),assert.deepEqual(utils.centroid(a),[150,150]),a.pop(),a.pop(),a.push([300,300]),assert.deepEqual(utils.centroid(a),[200,200])}),it('finds the center of a line between two points',()=>{assert.deepEqual([0,15],utils.findCenterPoint([0,10],[0,20]))}),it('finds the center of a non-flat line',()=>{assert.deepEqual([6.5,11.5],utils.findCenterPoint([0,0],[13,23]))}),it('finds the center a line given decimal endpoints',()=>{assert.deepEqual([6.65,11.77],utils.findCenterPoint([0,0],[13.3,23.54]))}),it('repositions the coordinate based on offset and scale.',()=>{assert.deepEqual([35.5,53],utils.locateRelativePointOnCanvas({x:10,y:20,w:5},[13,23],1.5))}),it('sets the appropriate visibility classes',()=>{function a(a){const c=utils.getVisibilityClasses(a),d=a+'ed: ';assert.equal(c[a],!0,d+a+' should be true'),b.forEach(function(b){a!==b&&assert.equal(c[b],!1,d+b+' should be false')})}const b=['show','fade','hide','highlight','unhighlight'];b.forEach(function(b){a(b)})})});