'use strict';const utils=require('../test/utils'),ReactDOM=require('react-dom');describe('init',()=>{let a,b,c,d,e;const f=(a)=>{const b=Object.assign({apiAddress:'http://api.example.com/',controllerSocketTemplate:'wss://$server:$port/api',socketTemplate:'/model/$uuid/api',baseUrl:'http://example.com/',charmstoreURL:'http://1.2.3.4/',flags:{},gisf:!1,plansURL:'http://plans.example.com/',termsURL:'http://terms.example.com/',identityURL:'http://identity.example.com/'},a);return new e(b)};beforeAll((a)=>{YUI(GlobalConfig).use(MODULES,(b)=>{window.yui=b,window.GUI_VERSION={version:'1.2.3'},e=require('../app/init'),a()})}),beforeEach(()=>{b=[],c=utils.makeAppContainer(),a=f(),d=function(){return new function(){return{store:{},setItem:function(a,b){this.store[a]=b},getItem:function(a){return this.store[a]||null}}}}}),afterEach(()=>{b.forEach((a)=>a()),a.destructor(),c.remove()}),describe('Application basics',()=>{it('should produce a valid index',()=>{c.getAttribute('id').should.equal('test-container'),c.getAttribute('class').should.include('container')}),it('has flags defined in the application config if none provided',()=>{assert.deepEqual(a.applicationConfig.flags,{})}),describe('MAAS support',()=>{let b;beforeEach(()=>{b=document.createElement('div'),b.setAttribute('id','maas-server'),b.classList.add('hidden');const a=document.createElement('a'),d=document.createTextNode('MAAS UI');a.appendChild(d),b.appendChild(a),c.appendChild(b)}),afterEach(()=>{c.querySelector('#maas-server').remove(!0)});const d=function(a,b){assert.strictEqual(a.classList.contains('hidden'),!1),assert.strictEqual(a.querySelector('a').href,b)};it('shows a link to the MAAS server if provider is MAAS',()=>{assert.strictEqual(b.classList.contains('hidden'),!0),a.modelAPI.set('maasServer','http://1.2.3.4/MAAS'),d(b,'http://1.2.3.4/MAAS'),a.modelAPI.set('maasServer','http://example.com/MAAS'),d(b,'http://1.2.3.4/MAAS')}),it('shows a link to the MAAS server if already in the env',()=>{a.modelAPI.set('maasServer','http://1.2.3.4/MAAS'),d(b,'http://1.2.3.4/MAAS'),a.modelAPI.set('maasServer','http://example.com/MAAS'),d(b,'http://1.2.3.4/MAAS')}),it('does not show the MAAS link if provider is not MAAS',()=>{assert.strictEqual(b.classList.contains('hidden'),!0),a.modelAPI.set('maasServer',null),assert.strictEqual(b.classList.contains('hidden'),!0),a.modelAPI.set('maasServer','http://1.2.3.4/MAAS'),assert.strictEqual(b.classList.contains('hidden'),!0)})}),describe('_setupCharmstore',()=>{it('is called on application instantiation',()=>{assert.isNotNull(a.charmstore)}),it('is idempotent',()=>{assert.equal(typeof a.charmstore,'object'),assert.equal(a.charmstore.url,'http://1.2.3.4/v5'),a._setupCharmstore({charmstoreURL:'it broke'},window.jujulib.charmstore),assert.equal(a.charmstore.url,'http://1.2.3.4/v5','It should only ever create a single instance of the charmstore')})}),describe('_setupIdentity',()=>{it('is called on application instantiation',()=>{assert.isNotNull(a.identity)}),it('is idempotent',()=>{assert.equal(typeof a.identity,'object'),a._setupIdentity({getIdentityURL:()=>'broken'},window.jujulib.identity),assert.strictEqual(a.identity.getIdentityURL(),null,'It should only ever create a single instance of the identity service')})}),describe('romulus services',()=>{it('sets up API clients',()=>{assert.strictEqual(a.plans instanceof window.jujulib.plans,!0),assert.strictEqual(a.plans.url,'http://plans.example.com/v3'),assert.strictEqual(a.terms instanceof window.jujulib.terms,!0),assert.strictEqual(a.terms.url,'http://terms.example.com/v1')})})}),describe('File drag over notification system',()=>{describe('drag event attach and detach',()=>{it('binds the drag handlers',()=>{a.destructor();const c=sinon.stub(document,'addEventListener');b.push(c.restore),a=f(),assert.equal(3<=c.callCount,!0);const d=c.args;assert.equal(d[8][0],'dragenter'),assert.isFunction(d[0][1]),assert.equal(d[9][0],'dragover'),assert.isFunction(d[1][1]),assert.equal(d[10][0],'dragleave'),assert.isFunction(d[2][1])}),it('removes the drag handlers',()=>{a.destructor();const c=sinon.stub(document,'addEventListener'),d=sinon.stub(document,'removeEventListener');b.push(c.restore),b.push(d.restore);const e=f();e.destructor(),assert.equal(3<=d.callCount,!0);const g=d.args;assert.equal(g[51][0],'dragenter'),assert.isFunction(g[0][1]),assert.equal(g[52][0],'dragover'),assert.isFunction(g[1][1]),assert.equal(g[53][0],'dragleave'),assert.isFunction(g[2][1])})}),describe('_determineFileType',()=>{it('returns false if it\'s not a file being dragged',()=>{const b=a._determineFileType({types:['foo']});assert.equal(b,!1)}),it('returns "zip" for zip files',()=>{const b=a._determineFileType({types:['Files'],items:[{type:'application/zip'}]});assert.equal(b,'zip')}),it('returns "zip" for zip files in IE',()=>{const b=a._determineFileType({types:['Files'],items:[{type:'application/x-zip-compressed'}]});assert.equal(b,'zip')}),it('returns "yaml" for the yaml mime type',()=>{const b=a._determineFileType({types:['Files'],items:[{type:'application/x-yaml'}]});assert.equal(b,'yaml')}),it('returns "" if the browser does not support "items"',()=>{const b=a._determineFileType({types:['Files']});assert.equal(b,'')})}),describe('UI notifications',()=>{it('_renderDragOverNotification renders drop UI',()=>{const c=sinon.stub(),d=sinon.stub(ReactDOM,'render');b.push(d.restore),a.topology.fadeHelpIndicator=c,a._renderDragOverNotification(),assert.equal(c.callCount,1),assert.equal(c.lastCall.args[0],!0),assert.equal(d.callCount,1)}),it('_hideDragOverNotification hides drop UI',()=>{const c=sinon.stub(),d=sinon.stub(ReactDOM,'unmountComponentAtNode');b.push(d.restore),a.topology.fadeHelpIndicator=c,a._hideDragOverNotification(),assert.equal(c.callCount,1),assert.equal(c.lastCall.args[0],!1),assert.equal(d.callCount,1)})}),it('dispatches drag events properly: _appDragOverHandler',()=>{const c=sinon.stub(a,'_determineFileType').returns('zip'),d=sinon.stub(a,'_renderDragOverNotification'),e=sinon.stub(a,'_dragleaveTimerControl');b=b.concat([c.restore,d.restore,e]);const f=()=>{};a._appDragOverHandler({dataTransfer:'foo',preventDefault:f,type:'dragenter'}),a._appDragOverHandler({dataTransfer:{},preventDefault:f,type:'dragleave'}),a._appDragOverHandler({dataTransfer:{},preventDefault:f,type:'dragover'}),assert.equal(c.callCount,3),assert.equal(d.calledOnce,!0),assert.equal(e.callCount,3);const g=e.args;assert.equal(g[0][0],'start'),assert.equal(g[1][0],'start'),assert.equal(g[2][0],'stop')}),it('can start and stop the drag timer: _dragLeaveTimerControl',()=>{a._dragleaveTimerControl('start'),assert.equal(a._dragLeaveTimer!==void 0,!0),a._dragleaveTimerControl('stop'),assert.equal(null===a._dragLeaveTimer,!0)})}),describe('Application authentication',()=>{let b;beforeEach(()=>{b=new utils.SocketStub,a.destructor();const c=new window.jujugui.User({sessionStorage:d()});c.controller={user:'user',password:'password'},a=f({conn:b,user:c})}),afterEach(()=>{b=null});const c=function(a){assert.equal(a.type,'Admin'),assert.equal(a.request,'Login')};it('avoids trying to login if the env is not connected',()=>{assert.equal(0,b.messages.length)}),it('tries to login if the env connection is established',()=>{a.modelAPI.connect(),assert.equal(1,b.messages.length),c(b.last_message())}),it('avoids trying to login without credentials',()=>{a.modelAPI.get('user').controller=null,a.navigate=()=>{},assert.deepEqual(a.user.controller,{user:'',password:'',macaroons:null}),assert.equal(b.messages.length,0)}),it('tries to log in on first connection',()=>{a.modelAPI.connect(),assert.equal(1,b.messages.length),c(b.last_message())}),it('tries to re-login on disconnections',()=>{a.modelAPI.connect(),b.transient_close(),b.open(),assert.equal(1,b.messages.length,'no login messages sent'),c(b.last_message())}),it('tries to re-login with macaroons on disconnections',()=>{a.modelAPI.setAttrs({jujuCoreVersion:'2.0.0'}),a.modelAPI.get('user').controller={macaroons:['macaroon']},a.modelAPI.connect(),b.transient_close(),b.open(),assert.equal(2,b.messages.length,'no login messages sent');const c=b.last_message();assert.strictEqual(c.type,'Admin'),assert.strictEqual(c.request,'Login'),assert.deepEqual(c.params,{macaroons:[['macaroon']]})}),it('should allow closing the connection',(b)=>{a.modelAPI.connect(),a.modelAPI.close(()=>{assert.strictEqual(a.modelAPI.userIsAuthenticated,!1);let c=a.modelAPI.get('user').sessionStorage.store.modelCredentials;c=JSON.parse(c),assert.deepEqual(c,null),b()})}),it('sends a post to storefront after controller connection in GISF',()=>{a.destructor(),a=f({conn:b,gisf:!0}),sinon.stub(a,'maskVisibility'),sinon.stub(a,'navigate'),sinon.stub(a,'dispatch'),sinon.stub(a.state,'changeState'),sinon.stub(a,'_sendGISFPostBack'),sinon.stub(a,'_ensureLoggedIntoCharmstore'),document.dispatchEvent(new Event('login')),assert.equal(a._sendGISFPostBack.callCount,1),assert.equal(a._ensureLoggedIntoCharmstore.callCount,1)})}),describe('Application Connection State',()=>{it('should be able to handle env connection status changes',()=>{const b=new utils.SocketStub,c=new window.jujugui.User({sessionStorage:d()});c.controller={user:'user',password:'password'},a.destructor(),a=f({conn:b,user:c}),a.db.reset=sinon.stub(),a.modelAPI.login=sinon.stub(),a.modelAPI.connect(),b.open(),assert.equal(a.db.reset.callCount,0),assert.equal(a.modelAPI.login.calledOnce,!0),b.transient_close(),b.open(),assert.equal(a.db.reset.callCount,0)}),describe('logout',()=>{it('logs out from API connections and then reconnects',()=>{let b=!1,c=!1,d=!1,e=!1;a.db.reset=sinon.stub(),a.db.fireEvent=sinon.stub();const f={clear:sinon.stub()};a.controllerAPI.destroy(),a.controllerAPI={close:(a)=>{assert.strictEqual(c,!0,'controller: close called before model close'),b=!0,a()},connect:()=>{assert.strictEqual(b,!0,'controller: connect called before close'),d=!0},destroy:sinon.stub()},a.modelAPI.destroy(),a.modelAPI={close:(a)=>{c=!0,a()},connect:()=>{assert.strictEqual(c,!0,'model: connect called before close'),e=!0},destroy:sinon.stub(),get:sinon.stub().returns(f)},a.state.changeState=sinon.stub(),a._handleLogout(),assert.strictEqual(b,!0,'controller close'),assert.strictEqual(c,!0,'model closed'),assert.strictEqual(d,!0,'controller connect'),assert.strictEqual(e,!1,'model connect'),assert.strictEqual(a.db.reset.calledOnce,!0,'db.reset'),assert.strictEqual(a.db.fireEvent.calledOnce,!0,'db.fireEvent'),assert.strictEqual(a.db.fireEvent.lastCall.args[0],'update'),assert.strictEqual(f.clear.calledOnce,!0,'ecs.clear'),assert.equal(a.state.changeState.callCount,1),assert.deepEqual(a.state.changeState.args[0],[{model:null,profile:null,root:null,store:null}])}),it('clears the db changed timer when the app is destroyed',()=>{a._dbChangedTimer='I am the timer!';const c=clearTimeout;clearTimeout=sinon.stub(),b.push(()=>{clearTimeout=c}),a.destructor(),assert.strictEqual(clearTimeout.calledOnce,!0,'clear call'),assert.strictEqual(clearTimeout.lastCall.args[0],'I am the timer!')})})}),describe('switchEnv',()=>{let c;beforeEach(()=>{c=a.modelAPI.get('ecs'),c.clear=sinon.stub(),a.modelAPI.close=sinon.stub(),a.db.reset=sinon.stub(),a.db.fireEvent=sinon.stub()}),it('can connect to an env even if not currently connected',()=>{a.switchEnv('wss://example.com/ws','user','password'),assert.isTrue(c.clear.called,'ecs was not cleared.'),assert.isTrue(a.modelAPI.close.called,'env was not closed.'),assert.isTrue(a.db.reset.called,'db was not reset.'),assert.equal(a.db.fireEvent.args[0][0],'update','db was not updated.');const b=a.topology.topo;assert.isTrue(b.modules.ServiceModule.centerOnLoad,'canvas centering was not reset.')}),it('clears and resets the env, db, and ecs on change',()=>{a.switchEnv('wss://example.com/ws','user','password'),assert.isTrue(c.clear.called,'ecs was not cleared.'),assert.isTrue(a.modelAPI.close.called,'env was not closed.'),assert.isTrue(a.db.reset.called,'db was not reset.'),assert.equal(a.db.fireEvent.args[0][0],'update','db was not updated.');const b=a.topology.topo;assert.isTrue(b.modules.ServiceModule.centerOnLoad,'canvas centering was not reset.')}),it('can not clear and reset the db, and ecs on change',()=>{a.switchEnv('wss://example.com/ws','user','password',null,!0,!1),assert.isFalse(c.clear.called,'ecs was not cleared.'),assert.isTrue(a.modelAPI.close.called,'env was not closed.'),assert.isFalse(a.db.reset.called,'db was not reset.'),assert.isFalse(a.db.fireEvent.called)}),it('skips the reconnect when necessary',()=>{const c=sinon.stub(a.modelAPI,'connect');b.push(c.restore),a.switchEnv('','','',!1),a.switchEnv(),assert.equal(c.callCount,0)})}),describe('getUser',()=>{it('gets the set user for the supplied service',()=>{const b={name:'foo'};a.users={charmstore:b},assert.deepEqual(a.getUser('charmstore'),b)})}),describe('clearUser',()=>{it('clears the set user for the supplied service',()=>{a.users={charmstore:{name:'foo'}},a.clearUser('charmstore'),assert.equal(a.users.charmstore,void 0)})}),describe('storeUser',()=>{beforeEach(()=>{a.charmstore.whoami=sinon.stub()}),it('calls charmstore whoami for charmstore users',()=>{const b={user:'test'};a.storeUser('charmstore'),assert.equal(a.charmstore.whoami.callCount,1);const c=a.charmstore.whoami.lastCall.args[0];c(null,b);const d=a.users;assert.deepEqual(d.charmstore,b)}),it('renders the profile and breadcrumb if told to',()=>{const b={user:'test'};a.state._appStateHistory.push({test:'state'}),a._renderBreadcrumb=sinon.stub(),a._renderUserProfile=sinon.stub(),a.storeUser('charmstore',!0,!0),assert.equal(a.charmstore.whoami.callCount,1),a.charmstore.whoami.lastCall.args[0](null,b),assert.equal(a._renderBreadcrumb.callCount,1),assert.equal(a._renderUserProfile.callCount,1),assert.deepEqual(a.users.charmstore,b)})}),describe('loginToAPIs',()=>{const b=(a)=>{return{destroy:sinon.stub(),name:'test-api',get:sinon.stub().withArgs('connected').returns(a),login:sinon.stub(),loginWithMacaroon:sinon.stub()}},c=(b,c,d)=>{if(d)void 0===d.macaroons&&(d.macaroons=null),assert.deepEqual(a.user.controller,d);else{assert.deepEqual(a.user.controller,{user:'',password:'',macaroons:null})}c?(assert.strictEqual(b.login.calledOnce,!0),assert.strictEqual(b.login.getCall(0).args.length,0)):assert.strictEqual(b.login.called,!1)},d=(a,b)=>{return b?(assert.strictEqual(a.loginWithMacaroon.calledOnce,!0),void assert.strictEqual(a.loginWithMacaroon.getCall(0).args.length,2)):void assert.strictEqual(a.loginWithMacaroon.called,!1)};it('logs into all connected API backends',()=>{const d={user:'user-who@local',password:'passwd'},e=b(!0),f=b(!0);a.loginToAPIs(d,!1,[e,f]),c(e,!0,d),c(f,!0,d)}),it('logs into all default API backends',()=>{const d={user:'user-who@local',password:'passwd'};a.controllerAPI=b(!0),a.modelAPI.destroy(),a.modelAPI=b(!0),a.loginToAPIs(d,!1),c(a.controllerAPI,!0,d),c(a.modelAPI,!0,d)}),it('only logs into APIs if they are connected',()=>{const d={user:'user-who@local',password:'passwd'},e=b(!0),f=b(!1);a.loginToAPIs(d,!1,[e,f]),c(e,!0,d),c(f,!1,d)}),it('sets credentials even if no API is connected',()=>{const d={user:'user-who@local',password:'passwd'};a.controllerAPI=b(!1),a.modelAPI.destroy(),a.modelAPI=null,a.loginToAPIs(d,!1),c(a.controllerAPI,!1,d)}),it('does not set credentials if they are not provided',()=>{a.user.controller=null;const d=b(!0);a.loginToAPIs(null,!1,[d]),c(d,!0,null)}),it('logs into all connected API backends (macaroons)',()=>{const c=b(!0),e=b(!0);a.loginToAPIs({user:'user-who',password:'passwd'},!0,[c,e]),d(c,!0),d(e,!0)}),it('logs into all default API backends (macaroons)',()=>{a.controllerAPI=b(!0),a.modelAPI.destroy(),a.modelAPI=b(!0),a.loginToAPIs({user:'user-who',password:'passwd'},!0),d(a.controllerAPI,!0),d(a.modelAPI,!0)}),it('only logs into APIs if they are connected (macaroons)',()=>{const c=b(!0),e=b(!1);a.loginToAPIs({user:'user-who',password:'passwd'},!0,[c,e]),d(c,!0),d(e,!1)})}),describe('_ensureControllerConnection',()=>{it('connects to the controller if it needs to',()=>{a.controllerAPI.connect=sinon.stub(),a.controllerAPI.set('connecting',!1),a.controllerAPI.set('connected',!1),a._ensureControllerConnection({root:'store'},sinon.stub()),assert.strictEqual(a.controllerAPI.connect.callCount,1,'controller')}),it('does not connect to the controller if it is already connected',()=>{a._displayLogin=sinon.stub(),a.controllerAPI.connect=sinon.stub(),a.controllerAPI.set('connecting',!1),a.controllerAPI.login=sinon.stub(),a.controllerAPI.set('connected',!0),a._ensureControllerConnection({root:'store'},sinon.stub()),assert.strictEqual(a.controllerAPI.connect.callCount,0,'controller')}),it('does not connect to the controller if it is already connecting',()=>{a.controllerAPI.connect=sinon.stub(),a.controllerAPI.set('connecting',!0),a.controllerAPI.set('connected',!1),a._ensureControllerConnection({root:'store'},sinon.stub()),assert.strictEqual(a.controllerAPI.connect.callCount,0,'controller')})}),describe('checkUserCredentials',()=>{const b=(b)=>{const c=sinon.stub().withArgs(),d=sinon.stub(a,'_displayLogin');a.checkUserCredentials(b,c),assert.equal(c.callCount,1,'next not called'),assert.equal(d.callCount,0,'_displayLogin called')};it('calls next and returns if root state is new',()=>{b({root:'new'})}),it('calls next and returns if root state is store',()=>{b({root:'store'})}),it('does not display login if one of the apis is still connecting',()=>{a.controllerAPI.set('connecting',!0);const b=sinon.stub(),c=sinon.stub(a,'_displayLogin');a.checkUserCredentials({},b),assert.equal(c.callCount,0)}),it('does not login if all apis are not connected',()=>{a.controllerAPI.set('connected',!1),a.modelAPI.set('connected',!1);const b=sinon.stub(),c=sinon.stub(a,'_displayLogin');a.checkUserCredentials({},b),assert.equal(c.callCount,0)}),it('displays login if one of the apis is not authenticated',()=>{const b=sinon.stub(),c=sinon.stub(a,'_displayLogin');a.controllerAPI.set('connected',!0),a.controllerAPI.userIsAuthenticated=!1,a.checkUserCredentials({},b),assert.equal(c.callCount,2)}),it('displays login if one of the apis is not authd and not gisf',()=>{const b=sinon.stub(),c=sinon.stub(a,'_displayLogin');a.controllerAPI.set('connected',!0),a.controllerAPI.userIsAuthenticated=!1,a.checkUserCredentials({},b),assert.equal(c.callCount,2)}),it('does not login if all apis are authenticated',()=>{a.controllerAPI.userIsAuthenticated=!0,a.modelAPI.userIsAuthenticated=!0;const b=sinon.stub(),c=sinon.stub(a,'_displayLogin');a.checkUserCredentials({},b),assert.equal(c.callCount,0)})}),describe('_disambiguateUserState',function(){it('properly handles a rejected entity promise',(b)=>{const c={user:'hatch'},d=Promise.reject(c);a.controllerAPI.userIsAuthenticated=!0,a._listAndSwitchModel=(a)=>{assert.deepEqual(a,c),b()},a._disambiguateUserState(d)}),it('properly handles a resolved entity promise',(b)=>{const c=Promise.resolve('hatch');a.maskVisibility=sinon.stub(),a.state.changeState=(c)=>{assert.deepEqual(a.maskVisibility.args[0],[!1]),assert.deepEqual({store:'u/hatch',user:null},c),b()},a._disambiguateUserState(c)})}),describe('_controllerIsReady',()=>{beforeEach(()=>{a._displayLogin=sinon.stub()}),it('reports true when the controller API is ready',()=>{a.controllerAPI.set('connected',!0),a.controllerAPI.userIsAuthenticated=!0,assert.strictEqual(a._controllerIsReady(),!0)}),it('reports false when the controller API is not ready',()=>{const b=a.controllerAPI;b.set('connected',!1),b.userIsAuthenticated=!1,a.controllerAPI=null,assert.strictEqual(a._controllerIsReady(),!1,'no controller'),a.controllerAPI=b,assert.strictEqual(a._controllerIsReady(),!1,'not connected'),a.controllerAPI.set('connected',!0),assert.strictEqual(a._controllerIsReady(),!1,'not authenticated')})}),describe('_listAndSwitchModel',()=>{let b;beforeEach(()=>{b=[{id:'fe9a2845-4829-4d61-8653-248b7052204e',name:'latta',series:'xenial',provider:'gce',uuid:'fe9a2845-4829-4d61-8653-248b7052204e',controllerUUID:'a030379a-940f-4760-8fcf-3062b41a04e7',owner:'frankban@external',life:'alive',isAlive:!0,isController:!1,lastConnection:null},{id:'509f6e4c-4da4-49c8-8f18-537c33b4d3a0',name:'jujugui-org',series:'xenial',provider:'gce',uuid:'509f6e4c-4da4-49c8-8f18-537c33b4d3a0',controllerUUID:'a030379a-940f-4760-8fcf-3062b41a04e7',owner:'uros-jovanovic@external',life:'alive',isAlive:!0,isController:!1,lastConnection:null}],a.maskVisibility=sinon.stub(),a.state.changeState=sinon.stub(),a.controllerAPI.listModelsWithInfo=(c)=>{c.call(a,null,b)}}),it('switches to a supplied model path',()=>{a._listAndSwitchModel('frankban/latta',null),assert.equal(a.maskVisibility.callCount,1),assert.deepEqual(a.maskVisibility.args[0],[!1]),assert.equal(a.state.changeState.callCount,1),assert.deepEqual(a.state.changeState.args[0],[{model:{path:'frankban/latta',uuid:'fe9a2845-4829-4d61-8653-248b7052204e'},user:null,root:null}])}),it('switches to a supplied model uuid',()=>{a._listAndSwitchModel(null,'509f6e4c-4da4-49c8-8f18-537c33b4d3a0'),assert.equal(a.maskVisibility.callCount,1),assert.deepEqual(a.maskVisibility.args[0],[!1]),assert.equal(a.state.changeState.callCount,1),assert.deepEqual(a.state.changeState.args[0],[{model:{path:'uros-jovanovic/jujugui-org',uuid:'509f6e4c-4da4-49c8-8f18-537c33b4d3a0'},user:null,root:null}])}),it('switches to disconnected state if no model is found via uuid',()=>{a._listAndSwitchModel(null,'bad-uuid'),assert.equal(a.maskVisibility.callCount,1),assert.deepEqual(a.maskVisibility.args[0],[!1]),assert.equal(a.state.changeState.callCount,1),assert.deepEqual(a.state.changeState.args[0],[{root:null,store:null,model:null,user:null,profile:''}])}),it('switches to disconnected state if no model found via path',()=>{a._listAndSwitchModel('bad/path',null),assert.equal(a.maskVisibility.callCount,1),assert.deepEqual(a.maskVisibility.args[0],[!1]),assert.equal(a.state.changeState.callCount,1),assert.deepEqual(a.state.changeState.args[0],[{root:null,store:null,model:null,user:null,profile:''}])})}),describe('_fetchEntityFromUserState',()=>{it('returns a promise for an entity',(b)=>{const c=sinon.stub().returns('~hatch/ghost');window.jujulib.URL.fromString=sinon.stub().returns({legacyPath:c});const d={getEntity:sinon.stub()};a.charmstore=d;const e=a._fetchEntityFromUserState('hatch/ghost');assert.equal(c.callCount,1,'legacy path not called'),assert.equal(d.getEntity.callCount,1,'getEntity not called'),assert.equal(d.getEntity.args[0][0],'~hatch/ghost'),d.getEntity.args[0][1](null,{}),e.then(()=>{b()})}),it('caches the entity promises',()=>{const b=sinon.stub().returns('~hatch/ghost');window.jujulib.URL.fromString=sinon.stub().returns({legacyPath:b});const c={getEntity:sinon.stub()};a.charmstore=c;const d=a._fetchEntityFromUserState('hatch/ghost');assert.deepEqual(a._userPaths.get('hatch/ghost'),{promise:d})}),it('returns a cached promise',()=>{const b=sinon.stub().returns('~hatch/ghost');window.jujulib.URL.fromString=sinon.stub().returns({legacyPath:b});const c={getEntity:sinon.stub()};a.charmstore=c;const d={promise:'its a promise'};a._userPaths.set('hatch/ghost',d);const e=a._fetchEntityFromUserState('hatch/ghost');assert.deepEqual(e,d.promise)})}),describe('_switchModelToUUID',()=>{it('switches to the provided uuid',()=>{a.switchEnv=sinon.stub(),a._switchModelToUUID('my-uuid'),assert.equal(a.modelUUID,'my-uuid'),assert.equal(a.switchEnv.callCount,1),assert.equal(a.switchEnv.args[0][0].endsWith('/model/my-uuid/api'),!0)}),it('switches to disconnected if none provided',()=>{a.switchEnv=sinon.stub(),a.createSocketURL=sinon.stub(),a._switchModelToUUID(),assert.strictEqual(a.modelUUID,null),assert.equal(a.createSocketURL.callCount,0),assert.equal(a.switchEnv.callCount,1),assert.deepEqual(a.switchEnv.args[0],[void 0])})}),describe('anonymous mode',()=>{let b;const c=(b)=>{a.destructor(),a=f(b),a._displayLogin=sinon.stub(),a._renderLogin=sinon.stub(),a._renderUserMenu=sinon.stub(),a.maskVisibility=sinon.stub(),a.loginToAPIs=sinon.stub(),a.reloadConfigFile=sinon.stub()};beforeEach(()=>{b=new window.jujugui.User({sessionStorage:d()}),b.controller={},c()});const e=()=>{if(!a.maskVisibility.called)return!1;const b=a.maskVisibility.args[0];return!b[0]};it('is disabled when the app is created',()=>{assert.strictEqual(a.anonymousMode,!1,'anonymousMode')}),it('is enabled when the controller connects in gisf mode',(d)=>{c({gisf:!0,user:b}),a.state={current:{root:'new'}},a.controllerAPI.after('connectedChange',()=>{assert.strictEqual(a.anonymousMode,!0,'anonymousMode'),assert.strictEqual(e(),!0,'appIsVisible'),assert.strictEqual(a._displayLogin.called,!1,'_displayLogin'),assert.strictEqual(a.loginToAPIs.called,!1,'loginToAPIs'),d()}),a.controllerAPI.set('connected',!0)}),it('is disabled when the controller connects but not in gisf',(d)=>{c({gisf:!1,user:b}),a.state={current:{root:'new'}},a.controllerAPI.after('connectedChange',()=>{assert.strictEqual(a.anonymousMode,!1,'anonymousMode'),assert.strictEqual(e(),!1,'appIsVisible'),assert.strictEqual(a._displayLogin.called,!0,'_displayLogin'),assert.strictEqual(a.loginToAPIs.called,!1,'loginToAPIs'),d()}),a.controllerAPI.set('connected',!0)}),it('is disabled when credentials are available',(d)=>{c({gisf:!0,user:b}),a.controllerAPI.get('user').controller={macaroons:'macaroons'},a.state={current:{root:'new'}},a.controllerAPI.after('connectedChange',()=>{assert.strictEqual(a.anonymousMode,!1,'anonymousMode'),assert.strictEqual(e(),!1,'appIsVisible'),assert.strictEqual(a._displayLogin.called,!1,'_displayLogin'),assert.strictEqual(a.loginToAPIs.called,!0,'loginToAPIs'),d()}),a.controllerAPI.set('connected',!0)}),it('is disabled when not in /new',(d)=>{c({gisf:!0,user:b}),a.state={current:{root:'store'}},a.controllerAPI.after('connectedChange',()=>{assert.strictEqual(a.anonymousMode,!1,'anonymousMode'),assert.strictEqual(e(),!1,'appIsVisible'),assert.strictEqual(a._displayLogin.called,!0,'_displayLogin'),assert.strictEqual(a.loginToAPIs.called,!1,'loginToAPIs'),d()}),a.controllerAPI.set('connected',!0)}),it('is disabled when in the homepage',(d)=>{c({gisf:!0,user:b}),a.state={current:{root:null}},a.controllerAPI.after('connectedChange',()=>{assert.strictEqual(a.anonymousMode,!1,'anonymousMode'),assert.strictEqual(e(),!1,'appIsVisible'),assert.strictEqual(a._displayLogin.called,!0,'_displayLogin'),assert.strictEqual(a.loginToAPIs.called,!1,'loginToAPIs'),d()}),a.controllerAPI.set('connected',!0)}),it('is kept enabled when previously enabled',(d)=>{c({gisf:!0,user:b}),a.anonymousMode=!0,a.state={current:{root:'store'}},a.controllerAPI.after('connectedChange',()=>{assert.strictEqual(a.anonymousMode,!0,'anonymousMode'),assert.strictEqual(e(),!0,'appIsVisible'),assert.strictEqual(a._displayLogin.called,!1,'_displayLogin'),assert.strictEqual(a.loginToAPIs.called,!1,'loginToAPIs'),d()}),a.controllerAPI.set('connected',!0)}),it('is kept enabled when previously enabled and in homepage',(d)=>{c({gisf:!0,user:b}),a.anonymousMode=!0,a.state={current:{root:null}},a.controllerAPI.after('connectedChange',()=>{assert.strictEqual(a.anonymousMode,!0,'anonymousMode'),assert.strictEqual(e(),!0,'appIsVisible'),assert.strictEqual(a._displayLogin.called,!1,'_displayLogin'),assert.strictEqual(a.loginToAPIs.called,!1,'loginToAPIs'),d()}),a.controllerAPI.set('connected',!0)}),it('is ignored when enabled but navigating to the login page',(d)=>{c({gisf:!0,user:b}),a.anonymousMode=!0,a.state={current:{root:'login'},changeState:()=>{}},a.controllerAPI.after('connectedChange',()=>{assert.strictEqual(a.anonymousMode,!0,'anonymousMode'),assert.strictEqual(e(),!1,'appIsVisible'),assert.strictEqual(a._displayLogin.called,!0,'_displayLogin'),assert.strictEqual(a.loginToAPIs.called,!1,'loginToAPIs'),d()}),a.controllerAPI.set('connected',!0)}),it('is disabled after successful login',(b)=>{const c=()=>{document.removeEventListener('login',c),assert.strictEqual(a.anonymousMode,!1,'anonymousMode'),assert.strictEqual(a._renderUserMenu.called,!0,'_renderUserMenu'),assert.equal(a.state.changeState.called,!0,'changeState');const d=a.state.changeState.args[0];assert.equal(d.length,1,'changeState num args'),assert.deepEqual(d[0],{root:null},'changeState args'),assert.equal(a.reloadConfigFile.callCount,1),b()};a.controllerAPI.after('connectedChange',()=>{document.addEventListener('login',c),a.anonymousMode=!0,a.state={current:{root:'login'},changeState:sinon.stub()},document.dispatchEvent(new CustomEvent('login',{detail:{err:null}}))}),a.controllerAPI.set('connected',!0)}),it('is disabled after failed login',(b)=>{a.anonymousMode=!0,a.state={current:{root:null}};const c=()=>{assert.strictEqual(a.anonymousMode,!1,'anonymousMode'),assert.strictEqual(a._renderLogin.called,!0,'_renderLogin'),document.removeEventListener('login',c),b()};document.addEventListener('login',c),document.dispatchEvent(new CustomEvent('login',{detail:{err:'bad wolf'}}))})}),describe('setPageTitle',()=>{it('can set the page title',()=>{document.title='Test',a.setPageTitle('Testing'),assert.equal(document.title,'Testing - Juju GUI')}),it('can set the default page title',()=>{document.title='Test',a.defaultPageTitle='Juju GUI',a.setPageTitle(),assert.equal(document.title,'Juju GUI')})})});